=== debian/changelog ===
moonphase (0.4.1-1mx17+1) mx; urgency=medium

  * Repackaged for MX Linux.

 -- Mike Purtell <mandbx@sbcglobal.net>  Mon, 11 Dec 2017 15:59:14 -0800

moonphase (0.4.1-1mx15+1) mx; urgency=medium

  * Rebuild for MX-15.
  * debian/control: add libqt4-dev build-depend.
  * debian/copyright: add info for wwwidgets.

 -- Steven Pusser <stevep@mxlinux.org>  Sun, 13 Nov 2016 12:39:40 -0800

moonphase (0.4.1-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Tue, 29 Dec 2015 19:00:00 -0700

moonphase (0.4.0-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Mon, 14 Dec 2015 14:05:00 -0700

moonphase (0.3.2-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Wed, 19 Aug 2015 13:35:00 -0700

moonphase (0.3.1-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Sun, 16 Aug 2015 14:35:00 -0700

moonphase (0.2.3-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Tue, 14 Oct 2014 19:12:00 -0700

moonphase (0.2.2-2) unstable; urgency=low

  * Corrected email address (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Fri,  5 Sep 2014 15:08:00 -0700

moonphase (0.2.2-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Thu,  4 Sep 2014 11:10:00 -0700

moonphase (0.2.1-1) unstable; urgency=low

  * New upstream version (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Thu, 31 Jul 2014 23:43:00 -0700

moonphase (0.2.0-1) unstable; urgency=low

  * Initial release (Closes: #nnnn)

 -- Alan Wise <alanwise@users.sourceforge.net>  Mon, 21 Jul 2014 16:24:19 -0700
